Index: /trunk/doc/manual/en_US/user_Introduction.xml
===================================================================
--- /trunk/doc/manual/en_US/user_Introduction.xml	(revision 88088)
+++ /trunk/doc/manual/en_US/user_Introduction.xml	(revision 88089)
@@ -4814,5 +4814,5 @@
       </para>
     </sect2>
-    <sect2 id="resource-monitor">
+    <sect2 id="vm-activity-overview-widget">
 
       <title>Resource Monitor</title>
@@ -4831,5 +4831,5 @@
         in the context menu.
       </para>
-      <figure id="fig-resource-monitor">
+      <figure id="fig-vm-activity-overview-widget">
         <title>Resource Monitor</title>
         <mediaobject>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 88089)
@@ -2626,5 +2626,5 @@
         default:
             {
-                AssertMsgFailed(("No text for VM Resource Monitor Column=%d", enmVMActivityOverviewColumn));
+                AssertMsgFailed(("No text for VM Activity Overview Widget Column=%d", enmVMActivityOverviewColumn));
                 break;
             }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 88089)
@@ -243,5 +243,5 @@
 const char *UIExtraDataDefs::GUI_HelpBrowserBookmarks = "GUI/HelpBrowserBookmarks";
 
-/* VM Resource Monitor: */
+/* VM Activity Overview Widget: */
 const char *UIExtraDataDefs::GUI_VMResourceManager_HiddenColumns = "GUI/VMResourceManagerHiddenColumns";
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 88089)
@@ -443,5 +443,5 @@
     /** @} */
 
-    /** @name Manager UI: VM Resource Monitor Related stuff
+    /** @name Manager UI: VM Activity Overview Related stuff
       * @{ */
         SHARED_LIBRARY_STUFF extern const char *GUI_VMResourceManager_HiddenColumns;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 88089)
@@ -796,5 +796,5 @@
     /** @} */
 
-    /** @name Manager UI: VM Resource Monitor
+    /** @name Manager UI: VM Activity Overview Widget
       * @{ */
         void setVMActivityOverviewHiddenColumnList(const QStringList &hiddenColumnList);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 88089)
@@ -354,5 +354,5 @@
 };
 
-/** Simple action extension, used as 'Show VM Resource Monitor' action class. */
+/** Simple action extension, used as 'Show VM Activity Overview Widget' action class. */
 class UIActionToggleManagerToolsGlobalShowVMActivityOverview : public UIActionToggle
 {
@@ -382,6 +382,6 @@
     virtual void retranslateUi() /* override */
     {
-        setName(QApplication::translate("UIActionPool", "&VM Resource Monitor"));
-        setStatusTip(QApplication::translate("UIActionPool", "Open the VM Resource Monitor"));
+        setName(QApplication::translate("UIActionPool", "&VM Activity Overview Widget"));
+        setStatusTip(QApplication::translate("UIActionPool", "Open the VM Activity Overview Widget"));
     }
 };
@@ -3439,5 +3439,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Columns"));
-        setShortcutScope(QApplication::translate("UIActionPool", "Resource Monitor"));
+        setShortcutScope(QApplication::translate("UIActionPool", "VM Activity Overview Widget"));
         setStatusTip(QApplication::translate("UIActionPool", "Show/Hide Columns"));
         setToolTip(  QApplication::translate("UIActionPool", "Show/Hide Columns")
@@ -3474,5 +3474,5 @@
     {
         setName(QApplication::translate("UIActionPool", "VM Activity"));
-        setShortcutScope(QApplication::translate("UIActionPool", "Resource Monitor"));
+        setShortcutScope(QApplication::translate("UIActionPool", "VM Activity Overview Widget"));
         setStatusTip(QApplication::translate("UIActionPool", "Switch to selected virtual machine's activity monitor pane"));
         setToolTip(  QApplication::translate("UIActionPool", "Switch to selected virtual machine's activity monitor pane")
@@ -3649,5 +3649,5 @@
     m_pool[UIActionIndexMN_M_CloudConsole_T_Details] = new UIActionMenuManagerCloudConsoleToggleProperties(this);
 
-    /* VM resource Monitor actions: */
+    /* VM Activity Overview Widget actions: */
     m_pool[UIActionIndexMN_M_VMActivityOverview] = new UIActionMenuVMActivityOverview(this);
     m_pool[UIActionIndexMN_M_VMActivityOverview_M_Columns] = new UIActionMenuManagerVMActivityOverviewColumns(this);
@@ -3787,5 +3787,5 @@
     updateMenuCloudWindow();
     updateMenuCloud();
-    /* 'VM Resource Monitor' menu: */
+    /* 'VM Activity Overview Widget' menu: */
     addMenu(m_mainMenus, action(UIActionIndexMN_M_VMActivityOverview));
     updateMenuVMActivityOverview();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h	(revision 88089)
@@ -190,5 +190,5 @@
     UIActionIndexMN_M_CloudConsole_T_Details,
 
-    /* VM Resource Monitor actions: */
+    /* VM VM Activity Overview Widget actions: */
     UIActionIndexMN_M_VMActivityOverview,
     UIActionIndexMN_M_VMActivityOverview_M_Columns,
@@ -298,7 +298,7 @@
     void updateMenuCloudConsoleWrapper(UIMenu *pMenu);
 
-    /** Updates 'VM Resource Monitor' menu. */
+    /** Updates 'VM VM Activity Overview' menu. */
     void updateMenuVMActivityOverview();
-    /** Updates 'VM Resource Monitor' @a pMenu. */
+    /** Updates 'VM VM Activity Overview' @a pMenu. */
     void updateMenuVMActivityOverviewWrapper(UIMenu *pMenu);
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 88089)
@@ -47,5 +47,5 @@
     , m_pPaneNetwork(0)
     , m_pPaneCloud(0)
-    , m_pPaneResourceMonitor(0)
+    , m_pPaneVMActivityOverview(0)
     , m_fActive(false)
 {
@@ -206,20 +206,20 @@
             {
                 /* Create VM Resource Monitor: */
-                m_pPaneResourceMonitor = new UIVMActivityOverviewWidget(EmbedTo_Stack, m_pActionPool, false /* show toolbar */);
-                AssertPtrReturnVoid(m_pPaneResourceMonitor);
-                {
-#ifndef VBOX_WS_MAC
-                    const int iMargin = qApp->style()->pixelMetric(QStyle::PM_LayoutLeftMargin) / 4;
-                    m_pPaneResourceMonitor->setContentsMargins(iMargin, 0, iMargin, 0);
-#endif
-
-                    /* Configure pane: */
-                    m_pPaneResourceMonitor->setProperty("ToolType", QVariant::fromValue(UIToolType_VMActivityOverview));
-                    connect(m_pPaneResourceMonitor, &UIVMActivityOverviewWidget::sigSwitchToMachinePerformancePane,
+                m_pPaneVMActivityOverview = new UIVMActivityOverviewWidget(EmbedTo_Stack, m_pActionPool, false /* show toolbar */);
+                AssertPtrReturnVoid(m_pPaneVMActivityOverview);
+                {
+#ifndef VBOX_WS_MAC
+                    const int iMargin = qApp->style()->pixelMetric(QStyle::PM_LayoutLeftMargin) / 4;
+                    m_pPaneVMActivityOverview->setContentsMargins(iMargin, 0, iMargin, 0);
+#endif
+
+                    /* Configure pane: */
+                    m_pPaneVMActivityOverview->setProperty("ToolType", QVariant::fromValue(UIToolType_VMActivityOverview));
+                    connect(m_pPaneVMActivityOverview, &UIVMActivityOverviewWidget::sigSwitchToMachinePerformancePane,
                             this, &UIToolPaneGlobal::sigSwitchToMachinePerformancePane);
 
                     /* Add into layout: */
-                    m_pLayout->addWidget(m_pPaneResourceMonitor);
-                    m_pLayout->setCurrentWidget(m_pPaneResourceMonitor);
+                    m_pLayout->addWidget(m_pPaneVMActivityOverview);
+                    m_pLayout->setCurrentWidget(m_pPaneVMActivityOverview);
                 }
 
@@ -288,5 +288,5 @@
             break;
         case UIToolType_VMActivityOverview:
-            pCurrentToolWidget = m_pPaneResourceMonitor;
+            pCurrentToolWidget = m_pPaneVMActivityOverview;
             break;
         default:
@@ -319,5 +319,5 @@
 {
     /* Determine whether resource monitor is currently active tool: */
-    if (m_pPaneResourceMonitor)
-        m_pPaneResourceMonitor->setIsCurrentTool(m_fActive && currentTool() == UIToolType_VMActivityOverview);
-}
+    if (m_pPaneVMActivityOverview)
+        m_pPaneVMActivityOverview->setIsCurrentTool(m_fActive && currentTool() == UIToolType_VMActivityOverview);
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 88089)
@@ -103,6 +103,6 @@
     /** Holds the Cloud Profile Manager instance. */
     UICloudProfileManagerWidget  *m_pPaneCloud;
-    /** Holds the VM Resource Monitor instance. */
-    UIVMActivityOverviewWidget   *m_pPaneResourceMonitor;
+    /** Holds the VM Activity Overview Widget instance. */
+    UIVMActivityOverviewWidget   *m_pPaneVMActivityOverview;
 
     /** Holds whether this pane is active. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/monitor/overview/UIVMActivityOverviewWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/monitor/overview/UIVMActivityOverviewWidget.cpp	(revision 88088)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/monitor/overview/UIVMActivityOverviewWidget.cpp	(revision 88089)
@@ -1358,5 +1358,5 @@
     retranslateUi();
     updateModelColumVisibilityCache();
-    uiCommon().setHelpKeyword(this, "resource-monitor");
+    uiCommon().setHelpKeyword(this, "vm-activity-overview-widget");
 }
 
@@ -1622,5 +1622,5 @@
 void UIVMActivityOverviewDialog::retranslateUi()
 {
-    setWindowTitle(UIVMActivityOverviewWidget::tr("VM Resource Monitor"));
+    setWindowTitle(UIVMActivityOverviewWidget::tr("VM Activity Overview"));
 }
 